#include <nds.h>
#include <fat.h>
#include <sys/stat.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <dirent.h>

#include "nds_loader_arm9.h"


//---------------------------------------------------------------------------------
int main(int argc, char **argv) {
//---------------------------------------------------------------------------------
	
	// Initialise the console, required for printf
	consoleDemoInit();
	
	if (fatInitDefault()) {

	FILE* fp = fopen("fat:/LOADFILE.DAT", "r"); //open file to read ROM to load
	FILE* fpo = fopen("fat:/ysmenu.ini", "w"); //open INI to write
	FILE* fpi = fopen("fat:/YSTEMPLATE.INI", "r"); //open template INI to maintain any settings there
	if(!fp) { iprintf("Error LOADFILE.DAT"); return 0; }
	if(!fpo) { iprintf("Error ysmenu.ini"); return 0; }
	if(!fpi) { iprintf("Error ystemplate.ini"); return 0; } //check for errors opening any files

	int x;
	
	while((x = fgetc(fpi)) != EOF) //read each character from template INI until End Of File
	{
		fputc(x, fpo); //write characters into new INI
	}

	fprintf(fpo, "\nAUTO_BOOT="); //add new line with "AUTO_BOOT="
	while((x = fgetc(fp)) != 0x0A) //read ROM path from .DAT
	{
		fprintf(fpo, "%c", x); //write ROM path to .INI
	}

	fprintf(fpo, "\n");
	fclose(fpo);
	fclose(fp);
	fclose(fpi);
	
	runNdsFile("fat:/ysmenu.nds", 0, 0); //run YSMenu
	}

	while(1) {
		swiWaitForVBlank();
	}

	return 0;
}
